import 'dart:convert';
import 'dart:js';
import 'dart:typed_data';

import 'compression_interface.dart';

class CompressionHelperImpl extends CompressionInterface {
  @override
  Uint8List base64DecodeAndzLibUncompress(Uint8List data) {
    Uint8List decodedData = base64.decode(utf8.decode(data));
    var compressedContent = context['pako'].callMethod("inflateRaw", [decodedData]);
    return Uint8List.fromList(compressedContent);
  }

  @override
  String zLibCompressAndEncodeBase64(Uint8List content) {
    var compressedContent = context['pako'].callMethod("deflateRaw", [content]);
    return base64.encode(compressedContent);
  }
}