import 'dart:convert';
import 'dart:io';
import 'dart:typed_data';

import 'compression_interface.dart';

class CompressionHelperImpl extends CompressionInterface {

  @override
    String zLibCompressAndEncodeBase64(Uint8List content) {
    var compressedContent = ZLibEncoder(raw: true).convert(content);
    return base64.encode(compressedContent);
  }

  @override
  Uint8List base64DecodeAndzLibUncompress(Uint8List data) {
    Uint8List decodedData = base64.decode(utf8.decode(data));
    return Uint8List.fromList(ZLibDecoder(raw:true).convert(decodedData));
  }


}