
import 'subject.dart';

class SubjectManager {
  final Map<String, Subject> subjectTable = {};

  void addSubjects(List<String> subjects, int history) {
    for (String subject in subjects) {
      if (!subjectTable.containsKey(subject)) {
        Subject sbj = Subject(subject, history);
        subjectTable[subject] = sbj;
      }
    }
  }

  List<Subject> removeSubjects(List<String> subjects) {
    List<Subject> removedSubjects = [];
    for (String subject in subjects) {
      Subject? s = subjectTable.remove(subject);
      if (s != null) {
        removedSubjects.add(s);
      }
    }
    return removedSubjects;
  }

  List<String> getAllSubjects() {
    return List<String>.unmodifiable(subjectTable.keys);
  }

  Subject? getSubject(String subject) {
    return subjectTable[subject];
  }

  bool containsSubject(String subject) {
    return subjectTable.containsKey(subject);
  }

  void resetSubjects() {
    for (var entry in subjectTable.values) {
      entry.reset();
    }
  }
}
