import '../migratorydata_log_listener.dart';
import 'console_logger_listener.dart';
import 'logger.dart';

class ConsoleLogger implements Logger {
  static final ConsoleLogger DEFAULT = ConsoleLogger();

  MigratoryDataLogLevel logLevel = MigratoryDataLogLevel.DEBUG;

  MigratoryDataLogListener logListener = ConsoleLoggerListener();

  @override
  void setMigratoryDataLogListener(
      MigratoryDataLogListener logListener, MigratoryDataLogLevel logLevel) {
    this.logListener = logListener;
    this.logLevel = logLevel;
  }

  @override
  bool isErrorEnabled() {
    return logLevel.index >= MigratoryDataLogLevel.ERROR.index;
  }

  @override
  bool isWarnEnabled() {
    return logLevel.index >= MigratoryDataLogLevel.WARN.index;
  }

  @override
  bool isInfoEnabled() {
    return logLevel.index >= MigratoryDataLogLevel.INFO.index;
  }

  @override
  bool isDebugEnabled() {
    return logLevel.index >= MigratoryDataLogLevel.DEBUG.index;
  }

  @override
  bool isTraceEnabled() {
    return logLevel.index >= MigratoryDataLogLevel.TRACE.index;
  }

  @override
  void error(String log) {
    logListener.onLog(log, MigratoryDataLogLevel.ERROR);
  }

  @override
  void warn(String log) {
    logListener.onLog(log, MigratoryDataLogLevel.WARN);
  }

  @override
  void info(String log) {
    logListener.onLog(log, MigratoryDataLogLevel.INFO);
  }

  @override
  void debug(String log) {
    logListener.onLog(log, MigratoryDataLogLevel.DEBUG);
  }

  @override
  void trace(String log) {
    logListener.onLog(log, MigratoryDataLogLevel.TRACE);
  }
}
